   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*             CLIPS Version 6.05  04/09/97            */
   /*                                                     */
   /*             SHORT LINK NAME HEADER FILE             */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

/******************************************************************/
/* This file redefines a number of global function and variable   */
/* definitions which are not distinguishable within 6 characters. */
/* This is done for linkers which only use less than the number   */
/* of significant characters used by the C compiler. Note that    */
/* the compiler should still be ANSI compliant in that it should  */
/* recognize at least 31 significant characters.                  */
/******************************************************************/

#ifndef _SHRTLNKN_HEADER_
#define _SHRTLNKN_HEADER_

#define AddAfterModuleChangeFunction             RN1
#define AddAfterModuleDefinedFunction            RN2
#define AddClearBloadReadyFunction               RN3
#define AddClearFunction                         RN4
#define AddClearReadyFunction                    RN5
#define AddConstruct                             RN6
#define AddConstructToModule                     RN7
#define AddFunctionToCallList                    RN8
#define AddHashedFact                            RN9
#define AgendaCommand                            RN10
#define AllocateExpressions                      RN11
#define AppendExpressions                        RN12
#define AppendNToString                          RN13
#define AppendStrings                            RN14
#define AppendToString                           RN15
#define ArgumentTypeToConstraintRecord           RN16
#define AssertCommand                            RN17
#define AssertString                             RN18
#define AssertStringFunction                     RN19
#define AssignBsaveDefmdlItemHdrVals             RN20
#define AssignBsavePatternHeaderValues           RN21
#define AssignClassID                            RN22
#define AssignFactSlotDefaults                   RN23
#define BinaryLoadInstancesCommand               RN24
#define BinaryPrefixID                           RN25
#define BinarySaveInstances                      RN26
#define BinarySaveInstancesCommand               RN27
#define BinaryVersionID                          RN28
#define BloadDeffactsModuleReference             RN29
#define BloadDeffunctionModuleReference          RN30
#define BloadDefgenericModuleReference           RN31
#define BloadDefglobalModuleReference            RN32
#define BloadDefinstancesModuleRef               RN33
#define BloadDefruleModuleReference              RN34
#define BloadDeftemplateModuleReference          RN35
#define BreakFunction                            RN36
#define BrowseClassesCommand                     RN37
#define BsaveConstructExpressions                RN38
#define BuildFunction                            RN39
#define CLIPSFunctionCall                        RN40
#define CallNextMethod                           RN41
#define ChangeToGlobals                          RN42
#define ChangesToInstances                       RN43
#define CheckArgumentAgainstRestriction          RN44
#define CheckConstraintParseConflicts            RN45
#define CheckCurrentMessage                      RN46
#define CheckRHSSlotTypes                        RN47
#define ClassAbstractPCommand                    RN48
#define ClassExistPCommand                       RN49
#define ClassInfoFnxArgs                         RN50
#define ClassReactivePCommand                    RN51
#define ClassSlotsCommand                        RN52
#define ClassSubclasses                          RN53
#define ClassSubclassesCommand                   RN54
#define ClassSuperclasses                        RN55
#define ClassSuperclassesCommand                 RN56
#define ClearBloadedConstraints                  RN57
#define ClearBloadedExpressions                  RN58
#define ClearDefgenericsReady                    RN59
#define ClearDefmethods                          RN60
#define ClearFocusStackCommand                   RN61
#define ClearRuleFromAgenda                      RN62
#define CloseAllFiles                            RN63
#define CloseFileIfNeeded                        RN64
#define CloseFunction                            RN65
#define CloseStringSource                        RN66
#define ConstantType                             RN67
#define ConstraintCheckDataObject                RN68
#define ConstraintCheckExpression                RN69
#define ConstraintCheckExpressionChain           RN70
#define ConstraintCheckValue                     RN71
#define ConstraintHashtable                      RN72
#define ConstraintReferenceErrorMessage          RN73
#define ConstraintViolationErrorMessage          RN74
#define ConstraintsToCode                        RN75
#define ConstructHeaderToCode                    RN76
#define ConstructJoins                           RN77
#define ConstructModuleToCode                    RN78
#define ConstructPrintWatchAccess                RN79
#define ConstructSetWatchAccess                  RN80
#define ConstructsToCCommand                     RN81
#define ConstructsToCCommandDefinition           RN82
#define ContinueEnvFunction                      RN83
#define CopyLHSParseNodes                        RN84
#define CreateFact                               RN85
#define CreateFactBySize                         RN86
#define CreateFunction                           RN87
#define CreateGetAndPutHandlers                  RN88
#define CreateImpliedDeftemplate                 RN89
#define CreateInitialFactPattern                 RN90
#define CreateMainModule                         RN91
#define CreateMultifield                         RN92
#define CreateMultifield2                        RN93
#define CreateRawInstance                        RN94
#define CreateSystemClasses                      RN95
#define CurrentEntityTimeTag                     RN96
#define CurrentEphemeralCountMax                 RN97
#define CurrentEphemeralSizeMax                  RN98
#define CurrentEvaluationDepth                   RN99
#define CurrentExpression                        RN100
#define CurrentGeneric                           RN101
#define CurrentMessageName                       RN102
#define CurrentMethod                            RN103
#define CurrentModule                            RN104
#define CurrentObjectSlotLength                  RN105
#define CurrentPatternFact                       RN106
#define CurrentPatternMarks                      RN107
#define CurrentPatternObject                     RN108
#define CurrentPatternObjectMarks                RN109
#define CurrentPatternObjectSlot                 RN110
#define CurrentPatternSegment                    RN111
#define DecrementDefclassBusyCount               RN112
#define DecrementFactBasisCount                  RN113
#define DecrementFactCount                       RN114
#define DecrementFloatCount                      RN115
#define DecrementIndentDepth                     RN116
#define DecrementInstanceCount                   RN117
#define DecrementIntegerCount                    RN118
#define DecrementSymbolCount                     RN119
#define DefclassConstruct                        RN120
#define DefclassInScope                          RN121
#define DefclassModuleIndex                      RN122
#define DefclassWatchAccess                      RN123
#define DefclassWatchPrint                       RN124
#define DeffactsBinarySetup                      RN125
#define DeffactsCModuleReference                 RN126
#define DeffactsCompilerSetup                    RN127
#define DeffactsConstruct                        RN128
#define DeffactsModuleFunction                   RN129
#define DeffactsModuleIndex                      RN130
#define DeffunctionConstruct                     RN131
#define DeffunctionModuleIndex                   RN132
#define DefgenericConstruct                      RN133
#define DefgenericModuleIndex                    RN134
#define DefglobalBasicCommands                   RN135
#define DefglobalBinarySetup                     RN136
#define DefglobalCConstructReference             RN137
#define DefglobalCModuleReference                RN138
#define DefglobalCommands                        RN139
#define DefglobalCompilerSetup                   RN140
#define DefglobalConstruct                       RN141
#define DefglobalModuleFunction                  RN142
#define DefglobalModuleIndex                     RN143
#define DefglobalPtrRecord                       RN144
#define DefineFunction2                          RN145
#define DefinstancesModuleIndex                  RN146
#define DefmoduleBasicCommands                   RN147
#define DefmoduleBinarySetup                     RN148
#define DefmoduleCompilerSetup                   RN149
#define DefruleBinarySetup                       RN150
#define DefruleCModuleReference                  RN151
#define DefruleCodeItem                          RN152
#define DefruleCommands                          RN153
#define DefruleCompilerSetup                     RN154
#define DefruleConstruct                         RN155
#define DefruleHasBreakpoint                     RN156
#define DefruleModuleFunction                    RN157
#define DefruleModuleIndex                       RN158
#define DefruleWatchAccess                       RN159
#define DefruleWatchPrint                        RN160
#define DeftemplateBasicCommands                 RN161
#define DeftemplateBinarySetup                   RN162
#define DeftemplateCConstructReference           RN163
#define DeftemplateCModuleReference              RN164
#define DeftemplateCommands                      RN165
#define DeftemplateCompilerSetup                 RN166
#define DeftemplateConstruct                     RN167
#define DeftemplateLHSParse                      RN168
#define DeftemplateModuleFunction                RN169
#define DeftemplateModuleIndex                   RN170
#define DeftemplatePtrRecord                     RN171
#define DeftemplateWatchAccess                   RN172
#define DeftemplateWatchPrint                    RN173
#define DeleteClassLinks                         RN174
#define DeleteClassUAG                           RN175
#define DeleteFunction                           RN176
#define DeleteHandler                            RN177
#define DeleteInstance                           RN178
#define DeleteInstanceCommand                    RN179
#define DeleteMethodInfo                         RN180
#define DeleteMultiValueField                    RN181
#define DeleteNamedConstruct                     RN182
#define DeletePackedClassLinks                   RN183
#define DeleteRouter                             RN184
#define DeleteSlotName                           RN185
#define DeleteSlots                              RN186
#define DeleteSubclassLink                       RN187
#define DeleteTempRestricts                      RN188
#define DeletedRuleDebugFlags                    RN189
#define DeletedTemplateDebugFlags                RN190
#define DependentsCommand                        RN191
#define DeriveVariableConstraints                RN192
#define DescribeClassCommand                     RN193
#define DestroyHandlerLinks                      RN194
#define DestroyPPBuffer                          RN195
#define DirectGetSlot                            RN196
#define DirectMVDeleteCommand                    RN197
#define DirectMVInsertCommand                    RN198
#define DirectMVReplaceCommand                   RN199
#define DirectMessage                            RN200
#define DirectModifyMsgHandler                   RN201
#define DirectPutSlot                            RN202
#define DirectPutSlotValue                       RN203
#define DisplayHandlersInLinks                   RN204
#define DribbleOff                               RN205
#define DribbleOffCommand                        RN206
#define DribbleOn                                RN207
#define DribbleOnCommand                         RN208
#define DuplicateInstance                        RN209
#define DuplicateMultifield                      RN210
#define DuplicateParse                           RN211
#define DynamicHandlerPutSlot                    RN212
#define EditCommand                              RN213
#define EditorRefresh                            RN214
#define EphemeralItemSize                        RN215
#define EvalFunction                             RN216
#define EvaluateExpression                       RN217
#define EvaluateJoinExpression                   RN218
#define EvaluateProcActions                      RN219
#define EvaluatingTopLevelCommand                RN220
#define EvaluationError                          RN221
#define ExecutingDeffunction                     RN222
#define ExecutingRule                            RN223
#define ExpandFuncCall                           RN224
#define ExpandStringWithChar                     RN225
#define ExpectedTypeError1                       RN226
#define ExpectedTypeError2                       RN227
#define ExpressionContainsVariables              RN228
#define ExpressionCount                          RN229
#define ExpressionDeinstall                      RN230
#define ExpressionHashTable                      RN231
#define ExpressionInstall                        RN232
#define ExpressionSize                           RN233
#define ExpressionToCode                         RN234
#define ExpressionToConstraintRecord             RN235
#define ExpressionToLHSParseNodes                RN236
#define ExtractModuleAndConstructName            RN237
#define ExtractModuleName                        RN238
#define FactCompVarsJNFunction2                  RN239
#define FactCompVarsJNFunction3                  RN240
#define FactCompVarsPNFunction2                  RN241
#define FactConstantPNFunction2                  RN242
#define FactConstantPNFunction4                  RN243
#define FactGVInfo2                              RN244
#define FactGVInfo3                              RN245
#define FactGVPN1Info                            RN246
#define FactGVPN2Info                            RN247
#define FactGVPN3Info                            RN248
#define FactGenCheckZeroLength                   RN249
#define FactGenGetfield                          RN250
#define FactGenGetvar                            RN251
#define FactGenPNConstant                        RN252
#define FactGetVarJNFunction1                    RN253
#define FactGetVarJNFunction2                    RN254
#define FactGetVarJNFunction3                    RN255
#define FactGetVarPNFunction1                    RN256
#define FactGetVarPNFunction2                    RN257
#define FactGetVarPNFunction3                    RN258
#define FactIndexFunction                        RN259
#define FactInfo                                 RN260
#define FactInstall                              RN261
#define FactJNCVInfo2                            RN262
#define FactJNCVInfo3                            RN263
#define FactJNVariableComparison                 RN264
#define FactPNConstantInfo2                      RN265
#define FactPNConstantInfo4                      RN266
#define FactPNVariableComparison                 RN267
#define FactPatternMatch                         RN268
#define FactPatternNodeReference                 RN269
#define FactPatternParse                         RN270
#define FactPatternParserFind                    RN271
#define FactPatternsCompilerSetup                RN272
#define FactReplaceGetvar                        RN273
#define FindDeffacts                             RN274
#define FindDeffunction                          RN275
#define FindDefgeneric                           RN276
#define FindDefglobal                            RN277
#define FindDefinstances                         RN278
#define FindDefmessageHandler                    RN279
#define FindDefmodule                            RN280
#define FindDefrule                              RN281
#define FindDeftemplate                          RN282
#define FindHandlerByIndex                       RN283
#define FindHandlerNameGroup                     RN284
#define FindHashedExpressions                    RN285
#define FindIDSlotNameHash                       RN286
#define FindImportedConstruct                    RN287
#define FindInstance                             RN288
#define FindInstanceBySymbol                     RN289
#define FindInstanceInModule                     RN290
#define FindInstanceSlot                         RN291
#define FindInstanceTemplateSlot                 RN292
#define FindModuleSeparator                      RN293
#define FindPreviewApplicableHandlers            RN294
#define FindSlotNameID                           RN295
#define FindSymbolMatches                        RN296
#define Function1Parse                           RN297
#define Function2Parse                           RN298
#define FunctionArray                            RN299
#define FunctionCallToConstraintRecord           RN300
#define GarbagePartialMatches                    RN301
#define GenGetPNObjectValue                      RN302
#define GenObjectPNConstantCompare               RN303
#define GenObjectZeroLengthTest                  RN304
#define GenericDispatch                          RN305
#define GensymStarFunction                       RN306
#define GetActivationPPForm                      RN307
#define GetAutoFloatDividendCommand              RN308
#define GetCompilationsWatch                     RN309
#define GetConstraintRecord                      RN310
#define GetConstructList                         RN311
#define GetConstructListFunction                 RN312
#define GetConstructModule                       RN313
#define GetConstructModuleCommand                RN314
#define GetConstructModuleItem                   RN315
#define GetConstructModuleItemByIndex            RN316
#define GetConstructModuleName                   RN317
#define GetConstructName                         RN318
#define GetConstructNameAndComment               RN319
#define GetConstructNamePointer                  RN320
#define GetConstructNameString                   RN321
#define GetConstructPPForm                       RN322
#define GetCurrentModuleCommand                  RN323
#define GetDefclassListFunction                  RN324
#define GetDefclassModuleCommand                 RN325
#define GetDefclassWatchInstances                RN326
#define GetDefclassWatchSlots                    RN327
#define GetDeffactsList                          RN328
#define GetDeffactsListFunction                  RN329
#define GetDeffactsModuleItem                    RN330
#define GetDeffunctionList                       RN331
#define GetDeffunctionListFunction               RN332
#define GetDeffunctionModuleCommand              RN333
#define GetDeffunctionWatch                      RN334
#define GetDefgenericList                        RN335
#define GetDefgenericListFunction                RN336
#define GetDefgenericModuleCommand               RN337
#define GetDefgenericWatch                       RN338
#define GetDefglobalList                         RN339
#define GetDefglobalListFunction                 RN340
#define GetDefglobalModuleItem                   RN341
#define GetDefglobalValue                        RN342
#define GetDefglobalValueForm                    RN343
#define GetDefglobalWatch                        RN344
#define GetDefinstancesList                      RN345
#define GetDefinstancesListFunction              RN346
#define GetDefinstancesModuleCommand             RN347
#define GetDefmessageHandlerList                 RN348
#define GetDefmessageHandlerPPForm               RN349
#define GetDefmessageHandlerType                 RN350
#define GetDefmessageHandlerWatch                RN351
#define GetDefmessageHandlersListCmd             RN352
#define GetDefmethodDescription                  RN353
#define GetDefmethodList                         RN354
#define GetDefmethodListCommand                  RN355
#define GetDefmethodPPForm                       RN356
#define GetDefmethodWatch                        RN357
#define GetDefmoduleList                         RN358
#define GetDefmoduleName                         RN359
#define GetDefmodulePPForm                       RN360
#define GetDefruleList                           RN361
#define GetDefruleListFunction                   RN362
#define GetDefruleModuleItem                     RN363
#define GetDefruleWatchActivations               RN364
#define GetDefruleWatchFirings                   RN365
#define GetDeftemplateList                       RN366
#define GetDeftemplateListFunction               RN367
#define GetDeftemplateModuleItem                 RN368
#define GetDeftemplateWatch                      RN369
#define GetFactDuplicationCommand                RN370
#define GetFactListChanged                       RN371
#define GetFactPPForm                            RN372
#define GetFactSlot                              RN373
#define GetFastSave                              RN374
#define GetFocusChanged                          RN375
#define GetFocusFunction                         RN376
#define GetFocusStack                            RN377
#define GetFocusStackFunction                    RN378
#define GetFunctionRestrictions                  RN379
#define GetGlobalsChanged                        RN380
#define GetIncrementalResetCommand               RN381
#define GetInstanceName                          RN382
#define GetInstancePPForm                        RN383
#define GetInstancesChanged                      RN384
#define GetMethodRestrictionsCommand             RN385
#define GetModuleName                            RN386
#define GetMvPrognIndex                          RN387
#define GetNextConstructItem                     RN388
#define GetNextDefclass                          RN389
#define GetNextDeffacts                          RN390
#define GetNextDeffunction                       RN391
#define GetNextDefgeneric                        RN392
#define GetNextDefglobal                         RN393
#define GetNextDefglobalInScope                  RN394
#define GetNextDefinstances                      RN395
#define GetNextDefmessageHandler                 RN396
#define GetNextDefmethod                         RN397
#define GetNextDefmodule                         RN398
#define GetNextDefrule                           RN399
#define GetNextDeftemplate                       RN400
#define GetNextFact                              RN401
#define GetNextFactInScope                       RN402
#define GetNextFocus                             RN403
#define GetNextInstance                          RN404
#define GetNextInstanceInClass                   RN405
#define GetNextInstanceInScope                   RN406
#define GetNextPatternEntity                     RN407
#define GetNextSymbolMatch                       RN408
#define GetNthRestriction                        RN409
#define GetNthWatchName                          RN410
#define GetNthWatchValue                         RN411
#define GetNumberOfDefmodules                    RN412
#define GetNumberOfFacts                         RN413
#define GetNumberOfModuleItems                   RN414
#define GetNumericArgument                       RN415
#define GetPPBufferStatus                        RN416
#define GetQueryInstanceSlot                     RN417
#define GetResetGlobalsCommand                   RN418
#define GetSalienceEvaluationCommand             RN419
#define GetStrategyCommand                       RN420
#define GlobalInfo                               RN421
#define GlobalJoin                               RN422
#define GlobalLHSBinds                           RN423
#define GlobalNumberOfInstances                  RN424
#define GlobalRHSBinds                           RN425
#define GlobalReferenceErrorMessage              RN426
#define GlobalSalience                           RN427
#define GreaterThanOrEqualFunction               RN428
#define HandlerDeleteError                       RN429
#define HandlerSlotGetFunction                   RN430
#define HandlerSlotPutFunction                   RN431
#define HandlerType                              RN432
#define HandlersExecuting                        RN433
#define HashInteger                              RN434
#define HelpFunctionDefinitions                  RN435
#define InactiveInitializeInstance               RN436
#define InactiveMakeInstance                     RN437
#define InactiveModifyInstance                   RN438
#define InactiveMsgDuplicateInstance             RN439
#define InactiveMsgModifyInstance                RN440
#define IncrementFactBasisCount                  RN441
#define IncrementFactCount                       RN442
#define IncrementIndentDepth                     RN443
#define IncrementInstanceCount                   RN444
#define IncrementalReset                         RN445
#define IncrementalResetInProgress               RN446
#define InitExpressionPointers                   RN447
#define InitializeAtomTables                     RN448
#define InitializeCLIPS                          RN449
#define InitializeClasses                        RN450
#define InitializeConstraintParseRecord          RN451
#define InitializeConstraints                    RN452
#define InitializeConstructHeader                RN453
#define InitializeConstructs                     RN454
#define InitializeDefaultRouters                 RN455
#define InitializeDeffacts                       RN456
#define InitializeDefglobals                     RN457
#define InitializeDefmodules                     RN458
#define InitializeDefrules                       RN459
#define InitializeDeftemplates                   RN460
#define InitializeEngine                         RN461
#define InitializeFactHashTable                  RN462
#define InitializeFactPatterns                   RN463
#define InitializeFactReteFunctions              RN464
#define InitializeFacts                          RN465
#define InitializeFileRouter                     RN466
#define InitializeInstanceCommand                RN467
#define InitializeInstanceTable                  RN468
#define InitializeMemory                         RN469
#define InitializePatternHeader                  RN470
#define InitializeStringRouter                   RN471
#define InsertHandlerHeader                      RN472
#define InsertMultiValueField                    RN473
#define InstallFunctionList                      RN474
#define InstallObjectPrimitives                  RN475
#define InstallPrimitive                         RN476
#define InstallProcedurePrimitives               RN477
#define InstanceAddressPCommand                  RN478
#define InstanceAddressesToNames                 RN479
#define InstanceExistPCommand                    RN480
#define InstanceGarbageList                      RN481
#define InstanceInfo                             RN482
#define InstanceList                             RN483
#define InstanceNameCommand                      RN484
#define InstanceNamePCommand                     RN485
#define InstanceNameToSymbol                     RN486
#define InstancePCommand                         RN487
#define InstanceTable                            RN488
#define Instances                                RN489
#define InstancesCommand                         RN490
#define InstancesPurge                           RN491
#define IntegerFunction                          RN492
#define IntegerpFunction                         RN493
#define IsDeffunctionDeletable                   RN494
#define IsDefglobalDeletable                     RN495
#define IsDefmethodDeletable                     RN496
#define keytab                                   RN497
#define LengthTestInfo                           RN498
#define LessThanOrEqualFunction                  RN499
#define ListConstructCommand                     RN500
#define ListDefclassesCommand                    RN501
#define ListDeffacts                             RN502
#define ListDeffactsCommand                      RN503
#define ListDeffunctions                         RN504
#define ListDeffunctionsCommand                  RN505
#define ListDefgenerics                          RN506
#define ListDefgenericsCommand                   RN507
#define ListDefglobals                           RN508
#define ListDefglobalsCommand                    RN509
#define ListDefinstances                         RN510
#define ListDefinstancesCommand                  RN511
#define ListDefmessageHandlers                   RN512
#define ListDefmessageHandlersCommand            RN513
#define ListDefmethods                           RN514
#define ListDefmethodsCommand                    RN515
#define ListDefmodules                           RN516
#define ListDefmodulesCommand                    RN517
#define ListDefrules                             RN518
#define ListDefrulesCommand                      RN519
#define ListDeftemplates                         RN520
#define ListDeftemplatesCommand                  RN521
#define ListDependencies                         RN522
#define ListDependents                           RN523
#define ListFocusStackCommand                    RN524
#define ListOfDefmodules                         RN525
#define ListOfModuleItems                        RN526
#define ListOfPatternParsers                     RN527
#define LoadConstructsFromLogicalName            RN528
#define LoadFactsCommand                         RN529
#define LoadInstancesCommand                     RN530
#define LookupDefclassAnywhere                   RN531
#define LookupDefclassByMdlOrScope               RN532
#define LookupDefclassInScope                    RN533
#define LookupDeffunctionByMdlOrScope            RN534
#define LookupDeffunctionInScope                 RN535
#define LookupDefgenericByMdlOrScope             RN536
#define LookupDefgenericInScope                  RN537
#define MVSlotInsertCommand                      RN538
#define MVSlotReplaceCommand                     RN539
#define MakeInstanceCommand                      RN540
#define MarkConstructHeaderNeededItems           RN541
#define MatchesCommand                           RN542
#define MemRequestsCommand                       RN543
#define MemUsedCommand                           RN544
#define MethodsExecuting                         RN545
#define ModifyInstance                           RN546
#define ModifyParse                              RN547
#define MsgDuplicateMsgHandler                   RN548
#define MsgModifyMsgHandler                      RN549
#define MultifieldDeinstall                      RN550
#define MultifieldFunctionDefinitions            RN551
#define MultifieldInstall                        RN552
#define MultifieldPrognFunction                  RN553
#define MultifieldpFunction                      RN554
#define MultifieldsEqual                         RN555
#define NumberpFunction                          RN556
#define NumericNotEqualFunction                  RN557
#define ObjectJNVariableComparison               RN558
#define ObjectMatchDelay                         RN559
#define ObjectNetworkAction                      RN560
#define ObjectNetworkPointer                     RN561
#define ObjectNetworkTerminalPointer             RN562
#define ObjectPNVariableComparison               RN563
#define ObjectParseToken                         RN565
#define ObjectPatternNodeReference               RN566
#define ObjectPatternsCompilerSetup              RN567
#define ObjectsRunTimeInitialize                 RN568
#define OpenFileIfNeeded                         RN569
#define OpenStringDestination                    RN570
#define OpenStringSource                         RN571
#define PPConstructCommand                       RN572
#define PPDeffactsCommand                        RN573
#define PPDeffunctionCommand                     RN574
#define PPDefglobal                              RN575
#define PPDefglobalCommand                       RN576
#define PPDefmethodCommand                       RN577
#define PPDefmodule                              RN578
#define PPDefmoduleCommand                       RN579
#define PPDefruleCommand                         RN580
#define PPDeftemplateCommand                     RN581
#define ParseAtomOrExpression                    RN582
#define ParseConstruct                           RN583
#define ParseDefclass                            RN584
#define ParseDeffacts                            RN585
#define ParseDeffunction                         RN586
#define ParseDefgeneric                          RN587
#define ParseDefglobal                           RN588
#define ParseDefmessageHandler                   RN589
#define ParseDefmethod                           RN590
#define ParseDefmodule                           RN591
#define ParseDefrule                             RN592
#define ParseDeftemplate                         RN593
#define ParseProcParameters                      RN594
#define ParseQueryNoAction                       RN595
#define ParseSlot                                RN596
#define ParseSlotOverrides                       RN597
#define ParseStandardConstraint                  RN598
#define ParseSuperclasses                        RN599
#define PatternNodeHeaderToCode                  RN600
#define PauseEnvFunction                         RN601
#define PopFocusFunction                         RN602
#define PreviewSend                              RN603
#define PreviewSendCommand                       RN604
#define PrimitiveTablesInfo                      RN605
#define PrimitivesArray                          RN606
#define PrintClassName                           RN607
#define PrintClassReference                      RN608
#define PrintConstraintReference                 RN609
#define PrintDeffunctionReference                RN610
#define PrintDefmoduleReference                  RN611
#define PrintExpression                          RN612
#define PrintFactGetVarJN1                       RN613
#define PrintFactGetVarJN2                       RN614
#define PrintFactGetVarJN3                       RN615
#define PrintFactGetVarPN1                       RN616
#define PrintFactGetVarPN2                       RN617
#define PrintFactGetVarPN3                       RN618
#define PrintFactIdentifier                      RN619
#define PrintFactInLongForm                      RN620
#define PrintFactJNCompVars1                     RN621
#define PrintFactJNCompVars2                     RN622
#define PrintFactJNCompVars3                     RN623
#define PrintFactPNCompVars2                     RN624
#define PrintFactWithIdentifier                  RN625
#define PrintFloat                               RN626
#define PrintFloatReference                      RN627
#define PrintFunctionReference                   RN628
#define PrintGenericName                         RN629
#define PrintHandlerSlotGetFunction              RN630
#define PrintHandlerSlotPutFunction              RN631
#define PrintHashedExpressionReference           RN632
#define PrintInstanceNameAndClass                RN633
#define PrintIntegerReference                    RN634
#define PrintMultifield                          RN635
#define PrintPNConstant4                         RN636
#define PrintPackedClassLinks                    RN637
#define PrintPartialMatch                        RN638
#define PrintProcParamArray                      RN639
#define PrintPrompt                              RN640
#define PrintSlotLengthTest                      RN641
#define PrintSymbolReference                     RN642
#define PrintTemplateFact                        RN643
#define ProcParamArraySize                       RN644
#define ProceduralFunctionParsers                RN645
#define PropagateReturnValue                     RN646
#define QueryDoForInstance                       RN647
#define QueryFindInstance                        RN648
#define ReadNeededConstraints                    RN649
#define RedrawScreenFunction                     RN650
#define RefreshAgenda                            RN651
#define RefreshAgendaCommand                     RN652
#define RefreshBooleanSymbols                    RN653
#define RefreshCommand                           RN654
#define RefreshExpressions                       RN655
#define ReleaseMemCommand                        RN656
#define ReleaseTraversalID                       RN657
#define RemoveAllActivations                     RN658
#define RemoveAllBreakpoints                     RN659
#define RemoveAllDefmodules                      RN660
#define RemoveAllExplicitMethods                 RN661
#define RemoveAllFacts                           RN662
#define RemoveAllUserClasses                     RN663
#define RemoveBatch                              RN664
#define RemoveBreak                              RN665
#define RemoveBreakCommand                       RN666
#define RemoveClassFromTable                     RN667
#define RemoveCleanupFunction                    RN668
#define RemoveClearFunction                      RN669
#define RemoveClearReadyFunction                 RN670
#define RemoveConstantFromConstraint             RN671
#define RemoveConstraint                         RN672
#define RemoveConstruct                          RN673
#define RemoveConstructFromModule                RN674
#define RemoveDeffunction                        RN675
#define RemoveDefgeneric                         RN676
#define RemoveEntityDependencies                 RN677
#define RemoveEphemeralAtoms                     RN678
#define RemoveFunction                           RN679
#define RemoveFunctionFromCallList               RN680
#define RemoveFunctionParser                     RN681
#define RemoveHashedExpression                   RN682
#define RemoveHashedFact                         RN683
#define RemoveInstanceData                       RN684
#define RemoveOldFacts                           RN685
#define RemovePMDependencies                     RN686
#define RemoveParsedBindName                     RN687
#define RemovePeriodicFunction                   RN688
#define RemoveResetFunction                      RN689
#define RemoveRunFunction                        RN690
#define RemoveSaveFunction                       RN691
#define ReorderPatterns                          RN692
#define ReplaceGetJNObjectValue                  RN693
#define ReplaceGetPNObjectValue                  RN694
#define ReplaceGlobalVariable                    RN695
#define ReplaceMultiValueField                   RN696
#define ReplaceProcVars                          RN697
#define ReplaceSequenceExpansionOps              RN698
#define RestoreBloadCount                        RN699
#define RestoreCurrentModule                     RN700
#define RestoreInstances                         RN701
#define RestoreInstancesCommand                  RN702
#define RetractCommand                           RN703
#define ReturnContext                            RN704
#define ReturnDefrule                            RN705
#define ReturnExpression                         RN706
#define ReturnFact                               RN707
#define ReturnFlag                               RN708
#define ReturnFunction                           RN709
#define ReturnLHSParseNodes                      RN710
#define ReturnMultifield                         RN711
#define ReturnPackedExpression                   RN712
#define ReturnPartialMatch                       RN713
#define ReturnSlots                              RN714
#define ReturnSymbolMatches                      RN715
#define ReturnValues                             RN716
#define SalienceInformationError                 RN717
#define SalienceNonIntegerError                  RN718
#define SalienceRangeError                       RN719
#define SaveConstruct                            RN720
#define SaveFactsCommand                         RN721
#define SaveInstancesCommand                     RN722
#define SequenceRestrictionParse                 RN723
#define SetAnyRestrictionFlags                   RN724
#define SetAutoFloatDividendCommand              RN725
#define SetBreakCommand                          RN726
#define SetCompilationsWatch                     RN727
#define SetConstraintType                        RN728
#define SetConstructPPForm                       RN729
#define SetContinueEnvFunction                   RN730
#define SetCurrentModuleCommand                  RN731
#define SetDefclassWatchSlots                    RN732
#define SetDeffunctionWatch                      RN733
#define SetDefgenericWatch                       RN734
#define SetDefglobalValue                        RN735
#define SetDefglobalWatch                        RN736
#define SetDefmessageHandlerWatch                RN737
#define SetDefmethodWatch                        RN738
#define SetDefruleWatchActivations               RN739
#define SetDefruleWatchFirings                   RN740
#define SetDeftemplateWatch                      RN741
#define SetFactDuplicationCommand                RN742
#define SetFactID                                RN743
#define SetFactListChanged                       RN744
#define SetFastSave                              RN745
#define SetIncrementalResetCommand               RN746
#define SetObjectNetworkTerminalPointer          RN747
#define SetResetGlobalsCommand                   RN748
#define SetSalienceEvaluationCommand             RN749
#define SetStrategyCommand                       RN750
#define SetupDeffunctions                        RN751
#define SetupDeffunctionsBload                   RN752
#define SetupDefinstances                        RN753
#define SetupDefinstancesBload                   RN754
#define SetupDefinstancesCompiler                RN755
#define SetupGenericsBload                       RN756
#define SetupGenericsCompiler                    RN757
#define SetupInstanceModDupCommands              RN758
#define SetupInstanceMultifieldCommands          RN759
#define SetupInstances                           RN760
#define SetupObjectPatternsBload                 RN761
#define SetupObjectSystem                        RN762
#define SetupObjectsBload                        RN763
#define SetupObjectsCompiler                     RN764
#define ShowBreaksCommand                        RN765
#define ShowDefglobalsCommand                    RN766
#define ShowFactPatternNetwork                   RN767
#define SlotAllowedValuesCommand                 RN768
#define SlotCardinalityCommand                   RN769
#define SlotDirectAccessPCommand                 RN770
#define SlotExistP                               RN771
#define SlotExistPCommand                        RN772
#define SlotFacetsCommand                        RN773
#define SlotInitablePCommand                     RN774
#define SlotPublicPCommand                       RN775
#define SlotRangeCommand                         RN776
#define SlotSourcesCommand                       RN777
#define SlotTypesCommand                         RN778
#define SlotWritablePCommand                     RN779
#define StringPrintForm                          RN780
#define StringToFact                             RN781
#define StringToMultifield                       RN782
#define StringpFunction                          RN783
#define SubclassPCommand                         RN784
#define SuperclassPCommand                       RN785
#define SymbolToInstanceName                     RN786
#define term                                     RN787
#define TempSize2                                RN788
#define TextLookupToss                           RN789
#define UnboundMethodErr                         RN790
#define UndefclassCommand                        RN791
#define Undefconstruct                           RN792
#define UndefconstructCommand                    RN793
#define UndeffactsCommand                        RN794
#define Undeffunction                            RN795
#define UndeffunctionCommand                     RN796
#define UndefgenericCommand                      RN797
#define Undefglobal                              RN798
#define UndefglobalCommand                       RN799
#define UndefinstancesCommand                    RN800
#define UndefmessageHandlerCommand               RN801
#define Undefmethod                              RN802
#define UndefmethodCommand                       RN803
#define UndefruleCommand                         RN804
#define UndeftemplateCommand                     RN805
#define UnmakeInstanceCommand                    RN806
#define UnwatchCommand                           RN807
#define UpdateDefmoduleItemHeader                RN808
#define UpdateDeftemplateScope                   RN809
#define UpdateMemoryRequests                     RN810
#define UpdateMemoryUsed                         RN811
#define UpdateModifyDuplicate                    RN812
#define UpdatePatternNodeHeader                  RN813
#define WatchFunctionDefinitions                 RN814
#define WatchGlobals                             RN815
#define WatchHandlers                            RN816
#define WatchMessages                            RN817
#define WatchMethods                             RN818
#define WriteNeededConstraints                   RN819
#define buffer_getc                              RN820
#define buffer_ungetc                            RN821
#define compile_region                           RN822
#define filevisit_guts                           RN823
#define genlongfree                              RN824
#define gotobol                                  RN825
#define gotoeol                                  RN826
#define kill_all_windows                         RN827
#define mlwrite                                  RN828
#define region_getc                              RN829
#define region_ungetc                            RN830
#define searchop                                 RN831
#define updateline                               RN832

#endif

